/**************************************************
**********                               **********
**********  PROGRAM: COMPILER CONSTANTS  **********
**********  Version: 1.00                **********
**********  BC.SOLARSKI (C) 2008/10      **********
**********  solarskit.wz.cz              **********
**********  solarskit@gmail.com          **********
**********	last revision:               **********
**********	30.10.2008 1405              **********
**********                               **********
**************************************************/

// size of buffers
#define SCI0_BUFFER_SIZE 32U

// ***** LEDs *****
#define CMD                   PORTK_BIT5
#define CMD_DDR               DDRK_BIT5
#define PWR                   PORTK_BIT4
#define PWR_DDR               DDRK_BIT4
#define ERR                   PTJ_PTJ1
#define ERR_DDR               DDRJ_DDRJ1
#define RUN                   PTJ_PTJ0
#define RUN_DDR               DDRJ_DDRJ0

// ***** MOTOR *****
// IN1-L
#define PWM1LENABLE           PWME_PWME7
#define PWM1LPOLARITY         PWMPOL_PPOL7
#define PWM1LPERIOD           PWMPER7
#define PWM1L                 PWMDTY7

// IN2-L
#define PWM2LENABLE           PWME_PWME6
#define PWM2LPOLARITY         PWMPOL_PPOL6
#define PWM2LPERIOD           PWMPER6
#define PWM2L                 PWMDTY6

// IN1-R
#define PWM1RENABLE           PWME_PWME3
#define PWM1RPOLARITY         PWMPOL_PPOL3
#define PWM1RPERIOD           PWMPER3
#define PWM1R                 PWMDTY3

// IN2-R
#define PWM2RENABLE           PWME_PWME2
#define PWM2RPOLARITY         PWMPOL_PPOL2
#define PWM2RPERIOD           PWMPER2
#define PWM2R                 PWMDTY2

// ***** PWM *****
#define PWM_CLKA              PWMPRCLK_PCKA
#define PWM_CLKB              PWMPRCLK_PCKB

// enable motor driver
#define ENABLE_LEFT           PTP_PTP5
#define ENABLE_RIGHT          PTP_PTP1
#define ENABLE_LEFT_DDR       DDRP_DDRP5
#define ENABLE_RIGHT_DDR      DDRP_DDRP1

// ***** ANALOG *****
#define BAT1                  ATD0DR0
#define BAT2                  ATD0DR1
#define BAT3                  ATD0DR2
#define BAT4                  ATD0DR3

#define CURRENT_LEFT          ATD0DR4
#define CURRENT_RIGHT         ATD0DR5

#define XOUT                  ATD1DR7
#define YOUT                  ATD0DR7
#define ZOUT                  ATD1DR6

#define BAT1koef              0.5F
#define BAT2koef              0.25F
#define BAT3koef              0.163934F
#define BAT4koef              0.117647F

#define VREF                  4.98F

// ***** TIME *****
#define TIMER_1MS             230U
#define TIME_RUN              250U
#define TIME_LOST_CONNECT     350U
#define TIME_ACCELERATE       3U