/**************************************************
**********                               **********
**********  PROGRAM: MCU INITIALIZATION  **********
**********  Version: 1.00                **********
**********  BC.SOLARSKI (C) 2008/10      **********
**********  solarskit.wz.cz              **********
**********  solarskit@gmail.com          **********
**********  MC9S12DP512                  **********
**********	last revision:               **********
**********	30.10.2008 1405              **********
**********                               **********
**************************************************/
void HCS12init( void )
{
  
  // LEDs
  PWR_DDR = 1;
  CMD_DDR = 1;
  RUN_DDR = 1;
  ERR_DDR = 1;
  
  // ***** TIMER 0 *****
  // nasataveni - 0 kanal OC
  TIOS_IOS0 = 1;
  // toggle output PT7
  TCTL2_OL0 = 1;
  TCTL2_OM0 = 0;
  // povoleni preruseni na 7 kanalu
  TIE_C0I = 1; 
  // hodnota pro compare 
  TC0 = TIMER_1MS;
  
  // ***** RUN TIMER *****
  // bus clock / 2^3   
  TSCR2 |= 3;
  // povoleni casovace
  TSCR1_TEN = 1;
  
  // ***** SCI0 - BT *****
  // 9600
  SCI0BD = 12;
  // povoleni preruseni od prijimace
  SCI0CR2_RIE = 1;
  // povoleni prijimace
  SCI0CR2_RE = 1;
  // povoleni vysilace
  SCI0CR2_TE = 1; 
  
  // ***** PWM MOTORS *****
  // 1.843.200 Hz / 2^1
  PWM_CLKA = 1;
  // 1.843.200 Hz / 2^1
  PWM_CLKB = 1;
  // polarity of PWM, start with 1 anf then go to 0
  PWM1LPOLARITY = 1;
  PWM2LPOLARITY = 1;
  PWM1RPOLARITY = 1;
  PWM2RPOLARITY = 1;
  // freq 18.43kHz
  PWM1LPERIOD = 100;
  PWM2LPERIOD = 100;
  PWM1RPERIOD = 100;
  PWM2RPERIOD = 100;
  // now the PWM is in percentage
  PWM1L = 0;
  PWM2L = 0;
  PWM1R = 0;
  PWM2R = 0;
  // run PWMs
  PWM1LENABLE = 1;
  PWM2LENABLE = 1;
  PWM1RENABLE = 1;
  PWM2RENABLE = 1;
  // ***** ENABLE MOTOR'S DRIVERS *****
  ENABLE_LEFT_DDR = 1;
  ENABLE_RIGHT_DDR = 1;
  ENABLE_LEFT = 1;
  ENABLE_RIGHT = 1;
  
  // ***** ANALOG *****
  // ***** AD PREVODNIK *****
  // zapnout AD prevodnik
  ATD0CTL2_ADPU = 1;
  ATD1CTL2_ADPU = 1;
  // povoleni preruseni
  ATD0CTL2_ASCIE = 0;  
  // konverze na vsech kanalech
  ATD0CTL3_S8C = 1;
  ATD1CTL3_S8C = 1;
  // ATDclock je BUSclk / 2 = 0.9216MHz ( 0.5 - 2MHz )
  ATD0CTL4_PRS = 0;
  // vzorkovani je 4 x ATDclock
  ATD0CTL4_SMP = 1;
  
  // ATDclock je BUSclk / 2 = 0.9216MHz ( 0.5 - 2MHz )
  ATD1CTL4_PRS = 0;
  // vzorkovani je 4 x ATDclock
  ATD1CTL4_SMP = 1;
  
  // vzorkovani na vsech kanalech
  ATD0CTL5_MULT = 1;
  ATD1CTL5_MULT = 1;
  // spojita konverze
  ATD0CTL5_SCAN = 1;
  ATD1CTL5_SCAN = 1;
  // zarovnani vpravo
  ATD0CTL5_DJM = 1;
  ATD1CTL5_DJM = 1;
  // povoleny vsechny vstupy
  ATD0DIEN = 0xFF;
  ATD1DIEN = 0xFF; 
}
